/***************************************************************************
 *   Copyright (C) 2003 by Johnathan Burchill,,,                           *
 *   jkerrb@shaw.ca                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef _GETUSERRESPONSETHREAD_H_
#define _GETUSERRESPONSETHREAD_H_

#include <qthread.h>
#include <qmutex.h>
#include <qstring.h>
#include <qwaitcondition.h>

#include <string>

class kdar;
class QSemaphore;
class KDarConfig;

class getUserResponseThread : public QThread 
{
public:

	getUserResponseThread( kdar * kdarWidget );
	virtual ~getUserResponseThread();
	
	virtual void run();
	virtual void setQuestion( QString userQuestion ) { question = userQuestion; }
	virtual QString getQuestion() const { return question; }
	static void interaction_warning_display(const std::string &message);
	static void tarListing( const std::string &flag,
							 const std::string &perm,
							 const std::string &uid,
							 const std::string &gid,
							 const std::string &size,
							 const std::string &date,
							 const std::string &filename);
	static bool interaction_pause(const std::string &message);
	void setKDarConfig( KDarConfig * );
	void setKDarWidget( kdar * kdarBaseWidget );
	void postQuestionEvent( const QString & userQuestion );
	
private:

	KDarConfig * m_kdc;
	QMutex mutex;
	QString question;
};

#endif // _GETUSERRESPONSETHREAD_H_
