/***************************************************************************
 *   Copyright (C) 2003 by Johnathan Burchill,,,                           *
 *   jkerrb@shaw.ca                                                        *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef KDARCREATEDIALOG_H
#define KDARCREATEDIALOG_H

#include "kdarcreatedlg.h"
#include "kdarfilefilterdialog.h"
#include "kdardirectoryfilterdialog.h"
#include "kdarcompressionfilterdialog.h"

class kdar;
class KDarConfig;

class kdarCreateDialog : public archiveCreateDlg
{
  Q_OBJECT

public:
  kdarCreateDialog( kdar * kdarWidget, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
  ~kdarCreateDialog();
  /*$PUBLIC_FUNCTIONS$*/
	void setKDarConfig( KDarConfig* createConfig );

public slots:
  /*$PUBLIC_SLOTS$*/
  virtual void          slotRemoveCompressionFilter();
  virtual void          slotRemoveAllCompressionFilter();
  virtual void          slotEditCompressionFilter();
  virtual void          slotNewCompressionFilter();
  virtual void          slotRemoveDirectoryFilter();
  virtual void          slotRemoveAllDirectoryFilter();
  virtual void          slotEditDirectoryFilter();
  virtual void          slotNewDirectoryFilter();
  virtual void          slotRemoveFileFilter();
  virtual void          slotRemoveAllFileFilter();
  virtual void          slotEditFileFilter();
  virtual void          slotNewFileFilter();
  virtual void          slotChooseArchiveName(const QString & theSelection);
  virtual void          slotChooseRootDirectory(const QString & theSelection);


protected:
  /*$PROTECTED_FUNCTIONS$*/

protected slots:
  /*$PROTECTED_SLOTS$*/

private:
	kdar *m_kdar;
	KDarConfig* m_createConfig;
	kdarDirectoryFilterDialog *directoryDlg;
	kdarFileFilterDialog *fileDlg;
	kdarCompressionFilterDialog *compressionDlg;
};

#endif

