/*
 * Copyright (C) 2003, 2004 Johnathan Burchill 
 * <jkerrb@users.sourceforge.net>
 */

#include "kdarview.h"

#include <qpainter.h>
#include <qpaintdevicemetrics.h>
#include <qevent.h>
#include <qlayout.h>
#include <qsimplerichtext.h>
#include <qstylesheet.h>

#include <kurl.h>
#include <ktrader.h>
#include <klibloader.h>
#include <kmessagebox.h>
#include <krun.h>
#include <klocale.h>
#include <kprinter.h>
#include <ktextbrowser.h>

#include "kdardialog.h"

kdarView::kdarView(QWidget *parent)
    : QWidget(parent),
      DCOPObject("kdarIface"),
	  kdarbase( new kdarDialog(this) )
{
    // setup our layout manager to automatically add our widgets
    QHBoxLayout *top_layout = new QHBoxLayout(this);
    top_layout->setAutoAdd(true);

    setAcceptDrops(true);
}

kdarView::~kdarView()
{
}

void kdarView::print(QPainter *p, KPrinter *printer, QPaintDeviceMetrics *metrics)
{
    // do the actual printing, here
    // p->drawText(etc..)

//    printer->setFullPage( TRUE );
//    if ( printer->setup(this) ) {               // printer dialog
//        statusBar()->message( "Printing..." );
//        QPainter p;
//        if( !p.begin( printer ) ) {               // paint on printer
//            statusBar()->message( "Printing aborted", 2000 );
//            return;
//        }
		//copied basically from $QTDIR/examples/action/application.cpp
//        QPaintDeviceMetrics metrics(p.device());
        //int dpiy = metrics->logicalDpiY();
        //int margin = (int) ( (2/2.54)*dpiy ); // 2 cm margins
        int margin = 0;
		QRect body( margin, margin, metrics->width()-2*margin, metrics->height()-2*margin );
        QSimpleRichText richText( QStyleSheet::convertFromPlainText (kdarbase->archiveTextBrowser->text()), kdarbase->archiveTextBrowser->font(), kdarbase->archiveTextBrowser->context(), kdarbase->archiveTextBrowser->styleSheet(), kdarbase->archiveTextBrowser->mimeSourceFactory(), body.height() );
		richText.setWidth( p, body.width() );
        QRect view( body );
        int page = 1;
        do {
            richText.draw( p, body.left(), body.top(), view, colorGroup() );
            view.moveBy( 0, body.height() );
            p->translate( 0 , -body.height() );
            p->drawText( view.right() - p->fontMetrics().width( QString::number( page ) ), view.bottom() + p->fontMetrics().ascent() + 5, QString::number( page ) );
            if ( view.top()  >= richText.height() )
                break;
            printer->newPage();
            page++;
        } while (TRUE);

//        statusBar()->message( "Printing completed", 2000 );
//   }// else {
//        statusBar()->message( "Printing aborted", 2000 );
    //}
}

#include "kdarview.moc"
